commit cfcf6459810b010e8af2798581967872f68f1178
Author: Jason Merrill <jason@redhat.com>
Date:   Thu Jan 6 15:45:26 2022

    c++: nested catch in ctor fn-try-block [PR61611]
    
    Being in_function_try_handler isn't enough to satisfy the condition of
    reaching the end of such a handler; in this case, we're reaching the end of
    a handler within that handler, so we don't want the special semantics.
    
            PR c++/61611
    
    gcc/cp/ChangeLog:
    
            * except.c (in_nested_catch): New.
            (expand_end_catch_block): Check it.
    
    gcc/testsuite/ChangeLog:
    
            * g++.dg/eh/ctor-fntry1.C: New test.

diff --git a/gcc/cp/except.c b/gcc/cp/except.c
index bc260d145d1..f53718c55f4 100644
--- a/gcc/cp/except.c
+++ b/gcc/cp/except.c
@@ -448,6 +448,23 @@ expand_start_catch_block (tree decl)
   return type;
 }
 
+/* True if we are in a catch block within a catch block.  Assumes that we are
+   in function scope.  */
+
+static bool
+in_nested_catch (void)
+{
+  int catches = 0;
+
+  /* Scan through the template parameter scopes.  */
+  for (cp_binding_level *b = current_binding_level;
+       b->kind != sk_function_parms;
+       b = b->level_chain)
+    if (b->kind == sk_catch
+	&& ++catches == 2)
+      return true;
+  return false;
+}
 
 /* Call this to end a catch block.  Its responsible for emitting the
    code to handle jumping back to the correct place, and for emitting
@@ -463,7 +480,8 @@ expand_end_catch_block (void)
      a handler of the function-try-block of a constructor or destructor.  */
   if (in_function_try_handler
       && (DECL_CONSTRUCTOR_P (current_function_decl)
-	  || DECL_DESTRUCTOR_P (current_function_decl)))
+	  || DECL_DESTRUCTOR_P (current_function_decl))
+      && !in_nested_catch ())
     {
       tree rethrow = build_throw (input_location, NULL_TREE);
       TREE_NO_WARNING (rethrow) = true;
diff --git a/gcc/testsuite/g++.dg/eh/ctor-fntry1.C b/gcc/testsuite/g++.dg/eh/ctor-fntry1.C
new file mode 100644
index 00000000000..0c783bb45ee
--- /dev/null
+++ b/gcc/testsuite/g++.dg/eh/ctor-fntry1.C
@@ -0,0 +1,23 @@
+// PR c++/61611
+// { dg-do run }
+
+struct A { };
+struct B { };
+
+struct Test
+{
+  Test()
+  try { throw A(); }
+  catch(const A&)
+    {
+      try { throw B(); }
+      catch(const B&) { }
+    }
+};
+
+int
+main()
+{
+  try { Test x; }
+  catch(const A&) { }
+}

